#include <wxnc/wxnc.hpp>
#include <cstdio>

#ifdef WX_NATIVE
#	define wxncApp        wxApp
#	define wxncBoxSizer   wxBoxSizer
#	define wxncButton     wxButton
#	define wxncCheckBox   wxCheckBox
#	define wxncColor      wxColour
#	define wxncDialog     wxDialog
#	define wxncFrame      wxFrame
#	define wxncMenu       wxMenu
#	define wxncMenuBar    wxMenuBar
#	define wxncStaticText wxStaticText
#	define wxncWindow     wxWindow
#	define SetBackgroundColor SetBackgroundColour
#endif

class MyApp : public wxncApp {
    public:
	bool OnInit(void);
};

class MyFrame : public wxncFrame {
    public:
	MyFrame(void);
};

class MyDialog : public wxncDialog {
    public:
	MyDialog(wxncWindow *);
};

#ifdef WX_NATIVE
IMPLEMENT_APP(MyApp);
#else
WXNC_IMPLEMENT_APP(MyApp);
#endif

bool MyApp::OnInit(void)
{
	srand(time(NULL));
	MyFrame *f = new MyFrame();
	f->Show(true);
	return true;
}

MyFrame::MyFrame(void) :
	wxncFrame(NULL, wxID_ANY, wxEmptyString)
{
	CreateStatusBar(2);
	SetStatusText(wxT("DEMO"), 0);

	wxncMenuBar *mb = new wxncMenuBar();

	wxncMenu *menu_file = new wxncMenu();
	wxncMenu *menu_edit = new wxncMenu();
	wxncMenu *menu_view = new wxncMenu();
	mb->Append(menu_file, wxT("File"));
	mb->Append(menu_edit, wxT("Credits"));
	mb->Append(menu_view, wxT("Another wxncMenu"));

	SetMenuBar(mb);

	(new MyDialog(this))->Show(true);
}

MyDialog::MyDialog(wxncWindow *parent) :
	wxncDialog(parent, wxID_ANY, wxT("Demo"), wxDefaultPosition,
		wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxMINIMIZE_BOX |
		wxMAXIMIZE_BOX)
{
	wxncBoxSizer *vp = new wxncBoxSizer(wxVERTICAL);
	wxncBoxSizer *hp = new wxncBoxSizer(wxHORIZONTAL);
	wxncCheckBox *cb;

	hp->Add(new wxncButton(this, wxID_ANY, _("OK")));
	hp->Add(new wxncButton(this, wxID_ANY, _("wxncButton")));
	hp->Add(new wxncButton(this, wxID_ANY, _("Sunken Border"), wxDefaultPosition, wxDefaultSize, wxBORDER_SUNKEN));
	vp->Add(new wxncStaticText(this, wxID_ANY, _("wxncStaticText")));
	vp->Add(new wxncCheckBox(this, wxID_ANY, _("wxncCheckBox off")));
	vp->Add(cb = new wxncCheckBox(this, wxID_ANY, _("wxncCheckBox on")));
	cb->SetValue(true);
	vp->Add(hp);
	vp->Add(new wxncButton(this, wxID_ANY, _("Static Border"), wxDefaultPosition, wxDefaultSize, wxBORDER_STATIC));
	SetSizer(vp);
	vp->SetSizeHints(this);
}
