#ifndef WXNC_COLOR_HPP
#define WXNC_COLOR_HPP 1

typedef unsigned int wxncRenderColor;

class wxncColor {
    public:
	wxncColor(void);
	wxncColor(unsigned char);
	wxncColor(unsigned char, unsigned char, unsigned char);
	virtual ~wxncColor(void);
	virtual void SetInvert(bool);

	static wxncRenderColor GetColor(const wxncColor &, const wxncColor &);
	static bool fgbg_compare(const wxncColor &, const wxncColor &);
	unsigned char nc_index(void) const;

	static unsigned char b_coherence_map[][4];

    protected:
	unsigned char m_bgcand, m_fgcand;
	bool m_invert, m_transparent;
};

extern const wxncColor
	wxncBLACK,    wxncRED,      wxncGREEN,  wxncBROWN,
	wxncBLUE,     wxncMAGENTA,  wxncCYAN,   wxncGRAY,
	wxncDARKGRAY, wxncHRED,     wxncHGREEN, wxncYELLOW,
	wxncHBLUE,    wxncHMAGENTA, wxncHCYAN,  wxncWHITE;

#endif /* WXNC_COLOR_HPP */
