#ifndef WXNC_SIZER_HPP
#define WXNC_SIZER_HPP 1

#include <list>
#include <wx/gdicmn.h>

class wxncWindow;

class wxncPackable {
    public:
	wxncPackable(const wxPoint & = wxDefaultPosition,
		const wxSize & = wxDefaultSize);
	virtual ~wxncPackable(void);

	int GetMinWidth(void) const;
	int GetMinHeight(void) const;
	virtual void GetMinSize(int *, int *) const;
	virtual wxSize GetMinSize(void) const;

	wxRect GetClientRect(void) const;
	wxSize GetClientSize(void) const;

	wxPoint GetPosition(void) const;
	virtual void SetPosition(int, int);
	virtual void SetPosition(const wxPoint &);

	int GetWidth(void) const;
	int GetHeight(void) const;
	wxSize GetSize(void) const;
	virtual void SetSize(const wxSize &);
	void SetSize(int, int);

	virtual void RecalcSizes(void) = 0;
	virtual void Layout(void) = 0;

    protected:
	wxSize m_minsize, m_size, m_clientsize;
	wxPoint m_pos, m_clientpos;

    private:
	DECLARE_NO_COPY_CLASS(wxncPackable);
};

class wxncSizer : public wxncPackable {
    public:
	wxncSizer(void);
	virtual ~wxncSizer(void);
	void Add(wxncPackable *, int = 0, int = 0, int = 0);
	void SetSizeHints(wxncWindow *);

    protected:
	std::list<wxncPackable *> window_list;

    private:
	DECLARE_NO_COPY_CLASS(wxncSizer);
};

#endif /* WXNC_SIZER_HPP */
