#ifndef WXNC_WINDOW_HPP
#define WXNC_WINDOW_HPP 1

#include <list>
#include <wxnc/color.hpp>
#include <wxnc/sizer.hpp>
#include <wx/defs.h>
#include <wx/gdicmn.h>

class wxncBoxSizer;

class wxncWindow : public wxncPackable {
    public:
	wxncWindow(wxncWindow * = NULL, wxWindowID = wxID_ANY,
		const wxPoint & = wxDefaultPosition,
		const wxSize & = wxDefaultSize, long = 0,
		const wxString & = wxPanelNameStr);
	virtual ~wxncWindow(void);

	virtual bool SetBackgroundColor(const wxncColor &);
	virtual bool SetForegroundColor(const wxncColor &);
	void SetSizer(wxncBoxSizer *, bool = true);
	void SetSize(const wxSize &);
	void SetSize(int, int);
	void SetPosition(const wxPoint &);
	void SetPosition(int, int);
	void Show(bool = true);
	virtual void RecalcSizes(void);
	virtual void Layout(void);
	virtual void Update(void);
	virtual void Refresh(void);

	void tree_dump(void);

    protected:
	void recalc_sizes_bh(void);
	virtual void render_background(int, int, int, int);
	virtual void render_border(int, int, int, int);

	long m_window_flags;
	wxncColor m_bgcolor, m_fgcolor;
	wxncBoxSizer *m_sizer;
	std::list<wxncWindow *> m_window_list;
};

#endif /* WXNC_WINDOW_HPP */
